<?php

namespace App\DataFixtures;

use App\Entity\Vente;
use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Persistence\ObjectManager;
use DateTime;

class VentesFixtures extends Fixture
{
    public function load(ObjectManager $manager): void
    {
        // Limites, pour tester.
        $maxEntities = 2_000_000_000;

        $fp = fopen(dirname(__DIR__) . '/ventes.txt', 'r');

        if ($fp === false) {
            print("Impossible d'ouvrir le fichier de ventes\n");
            return;
        }

        print("Fichier de ventes ouvert\n");

        // Ignorer ligne d'entêtes
        fgets($fp);

        $i = 0;
        $added = 0;

        while (($row = fgetcsv($fp, 0, '|'))) {

            if ($row[8] == "" || $row[10] == "" || $row[18] == "" || $row[35] == "" || $row[38] == "") {
                continue;
            }

            $vente = new Vente();

            $vente->setDate(DateTime::createFromFormat("d/m/Y", $row[8]));
            $vente->setValeur((float)$row[10]);
            $vente->setDepartement((int)$row[18]);
            $vente->setCodeType((int)$row[35]);
            $vente->setSurface((int)$row[38]);

            $manager->persist($vente);
            $added++;

            if ($added % 10000 == 0) {
                $manager->flush();
                $manager->clear();
                print("$added entités insérées\n");
            }

            if ($added > $maxEntities) {
                break;
            }
        }

        $manager->flush();

        print("[FIN] $added entités ajoutées\n");
    }
}
